import 'package:flutter/material.dart';
import 'package:partial_builds/app/app.locator.dart';
import 'package:partial_builds/app/app.router.dart';
import 'package:partial_builds/ui/views/partial_builds/partial_builds_view.dart';
import 'package:stacked_services/stacked_services.dart';

void main() {
  setupLocator();
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Flutter Demo',
      home: PartialBuildsView(),
      navigatorKey: StackedService.navigatorKey,
      onGenerateRoute: StackedRouter().onGenerateRoute,
    );
  }
}
